/*
 * Copyright 2009-2010 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

package jp.sf.fess.db.bsbhv.pmbean;

import java.io.Serializable;
import java.util.Date;

import org.seasar.dbflute.cbean.coption.FromToOption;
import org.seasar.dbflute.jdbc.FetchBean;
import org.seasar.dbflute.jdbc.ParameterUtil;
import org.seasar.dbflute.jdbc.ParameterUtil.ShortCharHandlingMode;
import org.seasar.dbflute.twowaysql.pmbean.ParameterBean;
import org.seasar.dbflute.util.DfTypeUtil;

/**
 * The parameter-bean of ClientIpRankingPmb.
 * @author DBFlute(AutoGenerator)
 */
public class BsClientIpRankingPmb extends
        org.seasar.dbflute.cbean.SimplePagingBean implements ParameterBean,
        FetchBean, Serializable {

    // ===================================================================================
    //                                                                          Definition
    //                                                                          ==========
    /** Serial version UID. (Default) */
    private static final long serialVersionUID = 1L;

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    /** fromRequestedTime:fromDate */
    protected Date _fromRequestedTime;

    /** toRequestedTime:toDate */
    protected Date _toRequestedTime;

    // ===================================================================================
    //                                                                         Constructor
    //                                                                         ===========
    public BsClientIpRankingPmb() {
    }

    // ===================================================================================
    //                                                                       Assist Helper
    //                                                                       =============
    protected String convertEmptyToNull(String value) {
        return ParameterUtil.convertEmptyToNull(value);
    }

    protected String handleShortChar(String propertyName, String value,
            Integer size) {
        ShortCharHandlingMode mode = getShortCharHandlingMode(propertyName,
                value, size);
        return ParameterUtil.handleShortChar(propertyName, value, size, mode);
    }

    protected ShortCharHandlingMode getShortCharHandlingMode(
            String propertyName, String value, Integer size) {
        return ShortCharHandlingMode.NONE;
    }

    @SuppressWarnings("unchecked")
    protected <NUMBER extends Number> NUMBER toNumber(Object obj,
            Class<NUMBER> type) {
        return (NUMBER) DfTypeUtil.toNumber(obj, type);
    }

    protected Boolean toBoolean(Object obj) {
        return DfTypeUtil.toBoolean(obj);
    }

    protected Date toUtilDate(Date date) {
        return DfTypeUtil.toDate(date); // if sub class, re-create as pure date
    }

    protected String formatUtilDate(Date date) {
        String pattern = "yyyy-MM-dd";
        return DfTypeUtil.toString(date, pattern);
    }

    protected String formatByteArray(byte[] bytes) {
        return "byte["
                + (bytes != null ? String.valueOf(bytes.length) : "null") + "]";
    }

    // ===================================================================================
    //                                                                      Basic Override
    //                                                                      ==============
    /**
     * @return The display string of all parameters. (NotNull)
     */
    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append(DfTypeUtil.toClassTitle(this)).append(":");
        sb.append(xbuildColumnString());
        return sb.toString();
    }

    private String xbuildColumnString() {
        final String c = ", ";
        final StringBuilder sb = new StringBuilder();
        sb.append(c).append(formatUtilDate(_fromRequestedTime));
        sb.append(c).append(formatUtilDate(_toRequestedTime));
        if (sb.length() > 0) {
            sb.delete(0, c.length());
        }
        sb.insert(0, "{").append("}");
        return sb.toString();
    }

    // ===================================================================================
    //                                                                            Accessor
    //                                                                            ========
    /**
     * [get] fromRequestedTime:fromDate
     * @return The value of fromRequestedTime. (Nullable, NotEmptyString(when String): if empty string, returns null)
     */
    public Date getFromRequestedTime() {
        return toUtilDate(_fromRequestedTime);
    }

    /**
     * [set as fromDate] fromRequestedTime:fromDate
     * @param fromRequestedTime The value of fromRequestedTime. (Nullable)
     */
    public void setFromRequestedTime_FromDate(Date fromRequestedTime) {
        _fromRequestedTime = new FromToOption().compareAsDate().filterFromDate(
                fromRequestedTime);
    }

    /**
     * [get] toRequestedTime:toDate
     * @return The value of toRequestedTime. (Nullable, NotEmptyString(when String): if empty string, returns null)
     */
    public Date getToRequestedTime() {
        return toUtilDate(_toRequestedTime);
    }

    /**
     * [set as toDate] toRequestedTime:toDate
     * @param toRequestedTime The value of toRequestedTime. (Nullable)
     */
    public void setToRequestedTime_ToDate(Date toRequestedTime) {
        _toRequestedTime = new FromToOption().compareAsDate().filterToDate(
                toRequestedTime);
    }

}
